// © Copyright Mocoolka Corporation 2015,2017.
// Node module: mocoolka-tools
// LICENSE: MIT
let  errorTools  = require('./error-tools.js');
/**
 * Array tools static class
 * @class ArrayTools
 */
class ArrayTools{
  /**
   * get array by order
   * @private
   * @param {Array} source source array
   * @param {number} order  the number to begin retrieve
   * @returns {Array}
   */
  static getArrayFromArrayByOrder(source, order) {
    if (!Array.isArray(source))
      return [];
    let argsLength = source.length;
    if (order >= argsLength) return [];
    let output = [];
    for (let ix = order; ix < argsLength; ix++) {
      output.push(source[ix]);
    }

    return output;
  };

  /**
   * get uniqueness array.remove repeat element.
   * @param {Array} source
   * @return {Array}
   */
  static uniquenessArray (source) {
    errorTools.validateJsonSchema({
      schema: schemas.uniquenessArray,
      data: source,
    });
    return [...new Set(source)];
  };
}
const schemas = {
  uniquenessArray: {
    type: 'array',
  },
};
module.exports = ArrayTools;

