// © Copyright Mocoolka Corporation 2015,2017.
// Node module: mocoolka-tools
// LICENSE: MIT
const errorTools= require('./error-tools.js');
/**
 * Global static class
 */
class GlobalTools {


  /**
   * set name-value in global
   * @param {Object} msg -param object
   * @propertyDetail {string} name -property name
   * @propertyDetail {*} value -property value
   */

  static setGlobalItem  (msg) {
    errorTools.validateJsonSchema
    ({ schema: schemas.setGlobalItem, data: msg });
    getGlobal()[msg.name] = msg.value;
  };

  /**
   * get value from Global using name
   * @param name
   * @return {*} value with key in Global
   */
  static getGlobalItem(name) {
    errorTools.validateJsonSchema
    ({ schema: schemas.getGlobalItem, data: name });
    return getGlobal()[name];
  };

}
/**
 * get global object. The will try window and global
 * @ignore
 * @return {Object} window | global
 */

const getGlobal = ()=> {
  return typeof window !== 'undefined' ?
    window : typeof global !== 'undefined' ? global : self;
};

const schemas = {
  setGlobalItem: {
    type: 'object',
    properties: {
      name: {
        type: 'string',
      },
      value: {
      },
    },
    required: ['name', 'value'],
  },

  getGlobalItem: {
    type: 'string',
  },

};
module.exports = GlobalTools;
