// © Copyright Mocoolka Corporation 2015,2017.
// Node module: mocoolka-tools
// LICENSE: MIT

const typeTools = require('./type-tools');
const errorTools= require('./error-tools.js');
/**
 * Iterator Object or Array
 * @class
 */
class IteratorTools {
  /**
   * iterator Object or array
   * @param {Object|Array} obj
   * @callback {Function} callback -return item when input is Array ,return object{key:key,value:obj[key] when
   * input is object
   * @param {Object} item -item in object
   * @propertyDetail {string} key -item key
   * @propertyDetail {Object} value -item value
   */
  static iterator  (obj, callback) {
    errorTools.validateJsonSchema
    ({ schema: schemas.iterator, data: obj });
    if (typeTools.isArray(obj)) {
      obj.map(value=> {
        callback(value);
      });
    } else if (typeTools.isObject(obj)) {
      Object.keys(obj).map(key=> {
        callback({ key: key, value: obj[key] });
      });
    }

    ;
  };
}
const schemas = {
  iterator: {
    anyOf: [
      { type: 'object' },
      { type: 'array' },
    ],
  },

};
module.exports = IteratorTools;
