// © Copyright Mocoolka Corporation 2015,2017.
// Node module: mocoolka-tools
// LICENSE: MIT

const osLocale = require('os-locale');
/**
 * operator system static tools class
 * @class
 */
class OSTools {
  /**
   * get os language
   * @returns {string} language
   */
  static getOSLanguage() {
    let locale = osLocale.sync();
    let lang = locale.substring(0, 2);
    if (lang === 'zh') {
      let region = locale.substring(3);
      if (region === 'CN') return 'zh-Hans';
      if (region === 'TW') return 'zh-Hant';
      if (region === 'Hans') return 'zh-Hans';
      if (region === 'Hant') return 'zh-Hant';
    }

    return lang;
  };

  /**
   * identifying the operating system platform on which the Node.js process is running.
   * @returns {string} 'darwin', 'freebsd', 'linux', 'sunos' or 'win32'
   */
  static getPlatform  () {
    return process.platform;
  };

}

module.exports = OSTools;
