const iteratorTools = require('./iterator-tools');
const typeTools = require('./type-tools');
const  { assert, should, expect } = require('chai');
/**
 * Test helper static tools
 */
class TestTools{
  static excuteTestCase(msg) {
    iteratorTools.iterator(msg.methods, item=> {
        it(item.key, function () {
          iteratorTools.iterator(item.value, testCase=> {
            if (testCase.case && testCase.expect) {
              if(testCase.init){
                testCase.init();
              }
              let result = msg.module[item.key](testCase.case);
              if (typeTools.isObject(testCase.expect) || typeTools.isArray(testCase.expect))
                expect(result).to.deep.equal(testCase.expect);
              else
                expect(result).to.be.equal(testCase.expect);
            }

            if (testCase.exceptions) {
              iteratorTools.iterator(testCase.exceptions, exception=> {
                exceptionFunctions[exception](msg.module[item.key]);
              });
            }
          });
        });
      });
  }
}
const exceptionFunctions = {
  blank(fun) {
    expect(function () {
      fun();
    }).to.throw();
  },
};
module.exports = TestTools;
