let Ajv = require('ajv');
let ajv = new Ajv({ useDefaults: true });
let schemaM = require('./schema/mocoolka.json');
require('ajv-keywords')(ajv, ['formatMinimum', 'formatMaximum', 'range']);
require('./mk-keywords/index')(ajv);

ajv.addMetaSchema(schemaM);
const schemaMap = new Map();
const validate = (msg, callback)=> {
  let schema = msg.schema;
  let data = msg.data;

  schema.$schema = 'mocoolka';
  let validateF = null;
  if (schemaMap.has(schema)) {
    validateF = schemaMap.get(schema);
  } else {
    validateF = ajv.compile(schema);
    schemaMap.set(schema, validateF);
  }

  let valid = validateF(data);
  if (!valid) {
    callback(validateF.errors);
  } else {
    callback(null);
  }

};

module.exports.__proto__ = {
  validate,
};

