/**
 * Node module: mocoolka-tools
 * @copyright © Copyright Mocoolka Corporation 2015,2017.
 * @license  MIT
 */


const watch = require('./watch/watch-file.js');
/**
 * monitor file or directory
 */
class WatchTools {
  /**
   * watch directory.
   * execute callback function when file change
   * @param {Object} msg - param object
   * @propertyDetail {string} path - root path
   * @propertyDetail {Function} callback - callback function
   * @propertyDetail {boolean} ignoreDotFiles -
   * When true this option means that when the file tree is walked
   * it will ignore files that being with "."
   * @propertyDetail {Function} filter -  You can use this option to provide a function
   * that returns true or false for each file and directory to decide
   * whether or not that file/directory is included in the watcher.
   * @propertyDetail {number} interval -Specifies the interval duration in seconds,
   * the time period between polling for file changes.
   * @propertyDetail {regex} ignoreDirectoryPattern -When a regex pattern is set,
   * e.g. /node_modules/, these directories are silently skipped.
   */

  static watchDirectory  (path, callback, options) {
    options = options || {};
    watch.createMonitor(path, options, function (monitor) {
      monitor.on('created', function (f, stat) {
        callback('created', f, stat);
      });
      monitor.on('changed', function (f, curr, prev) {
        callback('changed', f, curr, prev);
      });
      monitor.on('removed', function (f, stat) {
        callback('removed', f, stat);
      });
    });
    return watch;
  };
  static watchFile  (path, callback, options) {
    watchTools.watchDirectory(
      __dirname,
      (event, f, curr, prev)=> {
        if(event === 'changed'){

        }
      },
      {
        filter: (name) => (
          (fileTools.getFileName(name) === 'test.json')
        ),
        interval: 1,
      });
  };
}
const schemas = {
  watchDirectory: {
    type: 'array',
  },
};
module.exports = WatchTools;

